---
title: CanvasRenderingContext2D.textAlign
slug: Web/API/CanvasRenderingContext2D/textAlign
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Property
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.textAlign</code></strong> property of the Canvas 2D API specifies the current text alignment used when drawing text.</p>

<p>The alignment is relative to the <code>x</code> value of the {{domxref("CanvasRenderingContext2D.fillText", "fillText()")}} method. For example, if <code>textAlign</code> is <code>"center"</code>, then the text's left edge will be at <code>x - (textWidth / 2)</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.textAlign = "left" || "right" || "center" || "start" || "end";
</pre>

<h3 id="Options">Options</h3>

<p>Possible values:</p>

<dl>
 <dt><code>"left"</code></dt>
 <dd>The text is left-aligned.</dd>
 <dt><code>"right"</code></dt>
 <dd>The text is right-aligned.</dd>
 <dt><code>"center"</code></dt>
 <dd>The text is centered.</dd>
 <dt><code>"start"</code></dt>
 <dd>The text is aligned at the normal start of the line (left-aligned for left-to-right locales, right-aligned for right-to-left locales).</dd>
 <dt><code>"end"</code></dt>
 <dd>The text is aligned at the normal end of the line (right-aligned for left-to-right locales, left-aligned for right-to-left locales).</dd>
</dl>

<p>The default value is <code>"start"</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="General_text_alignment">General text alignment</h3>

<p>This example demonstrates the three "physical" values of the <code>textAlign</code> property: <code>"left"</code>, <code>"center"</code>, and <code>"right"</code>.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[13,16,19]">const canvas = document.getElementById('canvas');
canvas.width = 350;
const ctx = canvas.getContext('2d');
const x = canvas.width / 2;

ctx.beginPath();
ctx.moveTo(x, 0);
ctx.lineTo(x, canvas.height);
ctx.stroke();

ctx.font = '30px serif';

ctx.textAlign = 'left';
ctx.fillText('left-aligned', x, 40);

ctx.textAlign = 'center';
ctx.fillText('center-aligned', x, 85);

ctx.textAlign = 'right';
ctx.fillText('right-aligned', x, 130);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('General_text_alignment', 700, 180) }}</p>

<h3 id="Direction-dependent_text_alignment">Direction-dependent text alignment</h3>

<p>This example demonstrates the two direction-dependent values of the <code>textAlign</code> property: <code>"start"</code> and <code>"end"</code>. Note that the {{domxref("CanvasRenderingContext2D.direction", "direction")}} property is manually specified as <code>"ltr"</code>, although this is also the default for English-language text.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js; highlight:[7,10]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.font = '30px serif';
ctx.direction = 'ltr';

ctx.textAlign = 'start';
ctx.fillText('Start-aligned', 0, 50);

ctx.textAlign = 'end';
ctx.fillText('End-aligned', canvas.width, 120);
</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Direction-dependent_text_alignment', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-textalign", "CanvasRenderingContext2D.textAlign")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.textAlign")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this property: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
